package main

import (
	"context"
	"fmt"
	"log"
	"net/http"
	"os"
	"os/signal"
	"syscall"

	"git.vinchent.xyz/vinchent/go-web/framework"
)

func main() {
	core := framework.NewCore()
	registerRouter(core)
	server := &http.Server{
		Addr:    ":8080",
		Handler: core,
	}

	go func() {
		server.ListenAndServe()
	}()

	// create quit channel
	quit := make(chan os.Signal, 1)

	// set notifier
	signal.Notify(quit, syscall.SIGINT, syscall.SIGTERM, syscall.SIGQUIT)

	<-quit
	fmt.Println("YOLO")

	if err := server.Shutdown(context.Background()); err != nil {
		log.Fatal("server shutdown: ", err)
	}
}
